
' 
' Using Oxygen Assembler 'Asmosphere' project
' Charles E V Pegge
' 12:30 23/April/2008


' compiled with FreeBasic v.183
' fbc -s gui fbgfx_t.bas

' Requires Oxygen.dll
' Requires PlasmaColor2.asm

Extern "Windows-MS"
     DECLARE FUNCTION o2_asm       LIB "oxygen.dll" ALIAS "o2_asm"       (byval as zstring ptr) AS long ' assemble
     DECLARE FUNCTION o2_link      LIB "oxygen.dll" ALIAS "o2_link"      (byval as zstring ptr) AS long ' o2 link **
     DECLARE FUNCTION o2_view      LIB "oxygen.dll" ALIAS "o2_view"      (byval as zstring ptr) AS long ' o2 coding
     DECLARE FUNCTION o2_asm_file  LIB "oxygen.dll" ALIAS "o2_asm_file"  (byval as zstring ptr) AS long ' assemble from file
     DECLARE FUNCTION o2_view_file LIB "oxygen.dll" ALIAS "o2_view_file" (byval as zstring ptr) AS long ' o2 coding from file
     DECLARE FUNCTION o2_error     LIB "oxygen.dll" ALIAS "o2_error"     ()                     AS long ' error message if any
     DECLARE FUNCTION o2_len       LIB "oxygen.dll" ALIAS "o2_len"       ()                     AS long ' length of returned string
End Extern

     ' ** o2_link is automatically called by o2_asm when the assembly is successful.

#include once "windows.bi"
#include      "fbgfx.bi"

function gets(byval p as long) as string
    dim s as string
    dim l as long
    dim q as any ptr
    l=o2_len()
    s=space(l)
    if l=0 then goto xgets
    q=strptr(s)
    asm
        mov ecx,[l]
        mov esi,[p]
        mov edi,[q]
        strpt:
            mov al,[esi]
            mov [edi],al
            inc esi
            inc edi
            dec ecx
        jg strpt 
    end asm
    xgets:
    function=s
end function


    Const as string cr=chr$(13)+chr$(10)


    Dim as long a,b,work_page
    Dim as long w,h,x,y,i,syn,compo

    w=400 ' x boundary
    h=300 ' y boundary
    i=3   ' step
    syn=0 ' loop flag

    Dim as single page
    Dim as single c,t
    Dim as string he,fs,s, cod
    Dim as long fi=freefile
    fs="PlasmaColor2.asm"

    open fs for binary access read as fi
    s=space$(lof(fi))
    get$ #fi,,s
    close fi

    if len(s)=0 then print "no source to assemble: ":end


    ' create header to link host variables

    he=_
    "def #w     "+str$(@w)+cr+_
    "def #h     "+str$(@h)+cr+_
    "def #x     "+str$(@x)+cr+_
    "def #y     "+str$(@y)+cr+_
    "def #i     "+str$(@i)+cr+_
    "def #compo "+str$(@compo)+cr+_
    "def #syn   "+str$(@syn)+cr+_
    "def #t     "+str$(@t)+cr+_
    "def #c     "+str$(@c)+cr+_
    cr




    cod = gets(O2_ASM (he+s)) ' assemble header + main body of asm code
    if len(gets(O2_ERROR()))>0 then 
       messagebox 0, gets(O2_ERROR())+cr+"Program will end now","Error in ASM script",0
       end
    end if
    dim as any ptr Colorcalc =strptr(cod) ' pointer to binary code string

    Dim as double t1, t2


    ScreenRes w,h, 32

    '' start demo
    ''
    screenset 1, 0
    work_page = 1

    'Syntax for circles
    'Circle [target,] [STEP] (x,y), radius[, [color][, [start][, [end][, [aspect][, F]]]]]


    while InKey ="" 'Program runs until "q" is pressed
        screencopy 2, work_page
        t1 = gettickcount
        t+=1
        syn=1
        while syn
            asm call [ColorCalc] ' call the binary string
            circle ( x, y), i, compo
        wend
        screensync
        work_page xor= 1
        screenset work_page, work_page xor 1
        t2 = gettickcount 
    wend


'prior demo
'	do
'		screencopy 2, work_page
'		For a = 1 To 640
'		    For b = 1 To 480
'		        PSet (a,b),(a + b) And 1023
'		    Next b
'		Next a
'		screensync
'		work_page xor= 1
'		screenset work_page, work_page xor 1
'		
'	loop while inkey = ""
'